Index: trunk/NEMOGCM/EXTERNAL/XMLF90/src/dom/flib_dom.f90
===================================================================
--- trunk/NEMOGCM/EXTERNAL/XMLF90/src/dom/flib_dom.f90	(revision 2528)
+++ trunk/NEMOGCM/EXTERNAL/XMLF90/src/dom/flib_dom.f90	(revision 2528)
@@ -0,0 +1,17 @@
+module flib_dom
+
+  use m_dom_types
+  use m_dom_namednodemap
+  use m_dom_nodelist
+  use m_dom_attribute
+  use m_dom_document
+  use m_dom_node
+  use m_dom_element
+  use m_dom_parse
+  use m_dom_utils
+
+  use m_strings
+
+  public
+
+end module flib_dom
Index: trunk/NEMOGCM/EXTERNAL/XMLF90/src/dom/m_dom_attribute.f90
===================================================================
--- trunk/NEMOGCM/EXTERNAL/XMLF90/src/dom/m_dom_attribute.f90	(revision 2528)
+++ trunk/NEMOGCM/EXTERNAL/XMLF90/src/dom/m_dom_attribute.f90	(revision 2528)
@@ -0,0 +1,86 @@
+module m_dom_attribute
+
+use m_dom_types
+use m_dom_node
+use m_strings
+
+private
+  !-------------------------------------------------------  
+  ! METHODS FOR ATTRIBUTE NODES
+  !------------------------------------------------------- 
+
+  public :: getName
+  public :: getValue
+  public :: setValue
+
+CONTAINS
+
+  function getName(attribute)
+
+    type(fnode), intent(in) :: attribute
+    type(string)            :: getName
+
+    if (attribute % nodeType == ATTRIBUTE_NODE) then
+       getName = attribute%nodeName
+    else
+       getName = ''
+    endif
+
+  end function getName
+
+  !-----------------------------------------------------------
+
+  function getValue(attribute)
+
+    type(fnode), intent(in) :: attribute
+    type(string)            :: getValue
+
+    if (attribute % nodeType == ATTRIBUTE_NODE) then
+       getValue = attribute%nodeValue
+    else
+       getValue = ''
+    endif
+
+  end function getValue
+
+  !-----------------------------------------------------------
+
+  subroutine setValue(attribute, value)
+
+    character(len=*), intent(in) :: value
+    type(fnode), pointer  :: attribute
+
+    if (attribute % nodeType == ATTRIBUTE_NODE) then
+       call setNodeValue(attribute,value)
+    endif
+
+  end subroutine setValue
+
+  !-----------------------------------------------------------
+
+
+!!! NB Is this a good idea?
+!!! NB pure functions have no side effects
+
+  pure function attr_name_len(attribute)
+    type(fnode), intent(in) :: attribute
+    integer :: attr_name_len
+    if (attribute % nodeType == ATTRIBUTE_NODE) then
+       attr_name_len = len_trim(attribute % nodeName)
+    else
+       attr_name_len = 0
+    end if
+  end function attr_name_len
+  
+  pure function attr_val_len(attribute)   
+    type(fnode), intent(in) :: attribute
+    integer :: attr_val_len
+    if (attribute % nodeType == ATTRIBUTE_NODE) then
+       attr_val_len = len_trim(attribute % nodeValue)
+    else
+       attr_val_len = 0
+    end if
+  end function attr_val_len
+
+
+end module m_dom_attribute
Index: trunk/NEMOGCM/EXTERNAL/XMLF90/src/dom/m_dom_debug.f90
===================================================================
--- trunk/NEMOGCM/EXTERNAL/XMLF90/src/dom/m_dom_debug.f90	(revision 2528)
+++ trunk/NEMOGCM/EXTERNAL/XMLF90/src/dom/m_dom_debug.f90	(revision 2528)
@@ -0,0 +1,5 @@
+module m_dom_debug
+
+  logical, save, public :: dom_debug = .false.
+
+end module m_dom_debug
Index: trunk/NEMOGCM/EXTERNAL/XMLF90/src/dom/m_dom_document.f90
===================================================================
--- trunk/NEMOGCM/EXTERNAL/XMLF90/src/dom/m_dom_document.f90	(revision 2528)
+++ trunk/NEMOGCM/EXTERNAL/XMLF90/src/dom/m_dom_document.f90	(revision 2528)
@@ -0,0 +1,113 @@
+module m_dom_document
+
+use m_dom_types
+use m_strings
+
+private
+
+  !-------------------------------------------------------  
+  ! METHODS FOR DOCUMENT NODES
+  !-------------------------------------------------------   
+  public :: createDocumentNode
+  public :: createDocumentFragment
+  public :: createTextNode
+  public :: createAttribute
+  public :: createElement
+  public :: createComment
+  public :: createCdataSection
+
+CONTAINS
+
+  !-----------------------------------------------------------
+  ! METHODS FOR DOCUMENT NODES
+  !-----------------------------------------------------------
+
+  function createDocumentNode()
+
+    type(fnode), pointer :: createDocumentNode
+    
+    createDocumentNode => createNode()
+    createDocumentNode % nodeType = DOCUMENT_NODE
+    createDocumentNode % nodeName = "#document"
+    
+  end function createDocumentNode
+!-------------------------------------------------------------------
+  function createDocumentFragment()
+
+    type(fnode), pointer :: createDocumentFragment
+    
+    createDocumentFragment => createNode()
+    createDocumentFragment % nodeType = DOCUMENT_FRAGMENT_NODE
+    createDocumentFragment % nodeName = "#document-fragment"
+    
+  end function createDocumentFragment
+!-------------------------------------------------------------------
+  function createTextNode(data)
+
+    character(len=*), intent(in) :: data
+    type(fnode), pointer :: createTextNode
+    
+    createTextNode => createNode()
+    createTextNode % nodeType = TEXT_NODE
+    createTextNode % nodeName = "#text"
+    createTextNode % nodeValue = data  ! NB need to split this string 
+                                       ! across several nodes 
+    
+  end function createTextNode
+
+  !-----------------------------------------------------------
+
+  function createAttribute(name)
+    
+    character(len=*), intent(in) :: name
+    type(fnode), pointer :: createAttribute
+  
+    createAttribute => createNode()
+    createAttribute % nodeName = name
+    createAttribute % nodeType = ATTRIBUTE_NODE
+  
+  end function createAttribute
+
+  !-----------------------------------------------------------
+
+  function createElement(tagName)
+    
+    character(len=*), intent(in) :: tagName
+    type(fnode), pointer :: createElement
+  
+    createElement => createNode()
+    createElement % nodeName = tagName
+    createElement % nodeType = ELEMENT_NODE
+  
+  end function createElement
+
+  !-----------------------------------------------------------
+
+  function createComment(data)
+    
+    character(len=*), intent(in) :: data
+    type(fnode), pointer :: createComment
+  
+    createComment => createNode()
+    createComment % nodeName = "#comment"
+    createComment % nodeValue = data
+    createComment % nodeType = COMMENT_NODE
+  
+  end function createComment
+
+  !-----------------------------------------------------------
+
+  function createCdataSection(data)
+    
+    character(len=*), intent(in) :: data
+    type(fnode), pointer :: createCdataSection
+  
+    createCdataSection => createNode()
+    createCdataSection % nodeName = "#cdata-section"
+    createCdataSection % nodeValue = data
+    createCdataSection % nodeType = CDATA_SECTION_NODE
+  
+  end function createCdataSection
+
+  
+end module m_dom_document
Index: trunk/NEMOGCM/EXTERNAL/XMLF90/src/dom/m_dom_element.f90
===================================================================
--- trunk/NEMOGCM/EXTERNAL/XMLF90/src/dom/m_dom_element.f90	(revision 2528)
+++ trunk/NEMOGCM/EXTERNAL/XMLF90/src/dom/m_dom_element.f90	(revision 2528)
@@ -0,0 +1,242 @@
+module m_dom_element
+
+use m_dom_types
+use m_dom_namednodemap
+use m_dom_nodelist
+use m_dom_attribute
+use m_dom_document
+use m_dom_debug
+use m_dom_node
+use m_strings
+
+private
+
+  !-------------------------------------------------------   
+  ! METHODS FOR ELEMENT NODES
+  !-------------------------------------------------------   
+  public :: getTagName
+  public :: getElementsByTagName
+  public :: getAttribute
+  public :: getAttributeNode
+  public :: setAttribute
+  public :: setAttributeNode
+  public :: removeAttribute
+  public :: normalize       !--- combines adjacent text nodes ---!
+
+CONTAINS
+
+  !-----------------------------------------------------------
+  !  METHODS FOR ELEMENT NODES
+  !-----------------------------------------------------------
+  function getTagName(element)
+
+    type(fnode), intent(in) :: element   
+    type(string)            :: getTagName
+
+    if (element % nodeType == ELEMENT_NODE) then
+       getTagName = element % nodeName 
+    else
+       getTagName = ''
+    endif
+
+  end function getTagName
+
+  !-----------------------------------------------------------
+  function getElementsByTagName(element, tag) result(nodelist)
+    type(fnode), pointer         :: element
+    character(len=*), intent(in) :: tag
+    type(fnodeList), pointer     :: nodelist 
+
+    type(fnode), pointer        :: np
+
+    nodelist => null()
+
+    np => element
+    if (dom_debug) print *, "Going into search for tag: ", trim(tag)
+    call search(np)
+
+    CONTAINS
+
+    recursive subroutine search(np)
+    type(fnode), pointer        :: np
+
+    type(string)                :: name
+
+    !
+    ! Could replace the calls to helper methods by direct lookups of node 
+    ! components to make it faster.
+    ! 
+    do
+       if (.not. associated(np)) exit
+       select case(np%nodeType)
+
+          case(DOCUMENT_NODE) 
+             ! special case ... search its children 
+             if (hasChildNodes(np)) call search(getFirstChild(np))
+             ! will exit for lack of siblings
+          case(ELEMENT_NODE)
+
+             name = getNodeName(np)
+             if (dom_debug) print *, "exploring node: ", char(name)
+             if ((tag == "*") .or. (tag == name)) then
+                call append(nodelist,np)
+                if (dom_debug) print *, "found match ", nodelist%length
+             endif
+             if (hasChildNodes(np)) call search(getFirstChild(np))
+
+          case default
+             
+             ! do nothing
+
+        end select
+
+        if (associated(np,element)) exit  ! no siblings of element...
+        np => getNextSibling(np)
+
+     enddo
+    
+    end subroutine search
+
+  end function getElementsByTagName
+
+  !-----------------------------------------------------------
+
+  function getAttribute(element, name)
+    
+    type(fnode), intent(in) :: element
+    character(len=*), intent(in) :: name
+    type(string)                 :: getAttribute
+
+    type(fnode), pointer :: nn
+
+    getAttribute = ""  ! as per specs, if not found
+    if (element % nodeType /= ELEMENT_NODE) RETURN
+    nn => getNamedItem(element%attributes,name)
+    if (.not. associated(nn)) RETURN
+    
+    getAttribute = nn%nodeValue
+
+        
+  end function getAttribute
+
+  !-----------------------------------------------------------
+
+  function getAttributeNode(element, name)
+    
+    type(fnode), intent(in) :: element
+    type(fnode), pointer    :: getAttributeNode
+    character(len=*), intent(in) :: name
+
+    getAttributeNode => null()     ! as per specs, if not found
+    if (element % nodeType /= ELEMENT_NODE) RETURN
+    getAttributeNode => getNamedItem(element%attributes,name)
+
+  end function getAttributeNode
+  
+  !-----------------------------------------------------------
+
+  subroutine setAttributeNode(element, newattr)
+    type(fnode), pointer :: element
+    type(fnode), pointer :: newattr
+
+    type(fnode), pointer :: dummy
+
+    if (element % nodeType /= ELEMENT_NODE) then
+       if (dom_debug) print *, "not an element node in setAttributeNode..."
+       RETURN
+    endif
+
+    dummy => setNamedItem(element%attributes,newattr)
+     
+  end subroutine setAttributeNode
+
+!-------------------------------------------------------------------
+  subroutine setAttribute(element, name, value)
+    type(fnode), pointer :: element
+    character(len=*), intent(in) :: name
+    character(len=*), intent(in) :: value
+
+    type(fnode), pointer      :: newattr
+
+    newattr => createAttribute(name)
+    call setValue(newattr,value)
+    call setAttributeNode(element,newattr)
+
+  end subroutine setAttribute
+
+  !-----------------------------------------------------------
+
+  subroutine removeAttribute(element, name)
+    type(fnode), pointer :: element
+    character(len=*), intent(in) :: name
+
+    type(fnode), pointer :: dummy
+
+    if (element % nodeType /= ELEMENT_NODE) RETURN
+    if (.not. associated(element%attributes)) RETURN
+
+    dummy => removeNamedItem(element%attributes,name)
+     
+  end subroutine removeAttribute
+
+  !-----------------------------------------------------------
+  recursive subroutine normalize(element)
+    type(fnode), pointer         :: element
+
+    type(fnode), pointer        :: np, ghost
+    logical                     :: first
+
+    type(fnode), pointer        :: head
+
+    first = .true.  ! next Text node will be first
+
+    if (dom_debug) print *, "Normalizing: ", trim(element%nodeName)
+    np => element%firstChild
+    ! 
+    do
+       if (.not. associated(np)) exit
+       select case(np%nodeType)
+
+          case(TEXT_NODE) 
+             if (first) then
+                if (dom_debug) print *, "normalize: found first in chain"
+                head => np
+                first = .false.
+                np => getNextSibling(np)
+             else                    ! a contiguous text node
+                if (dom_debug) print *, "normalize: found second in chain"
+                head%nodeValue = head%nodeValue // np%nodeValue
+                head%nextSibling => np%nextSibling
+                if (associated(np,np%parentNode%lastChild)) then
+                   np%parentNode%lastChild => head
+                   head%nextSibling => null()
+                else
+                   np%nextSibling%previousSibling => head
+                endif
+                ghost => np
+                np => getNextSibling(np)
+                call destroyNode(ghost)
+             endif
+
+          case(ELEMENT_NODE)
+
+             first = .true.
+             if (dom_debug) print *, "element sibling: ", trim(np%nodeName)
+             if (hasChildNodes(np)) call normalize(np)
+             np => getNextSibling(np)
+
+          case default
+             
+             ! do nothing, just mark that we break the chain of text nodes
+             if (dom_debug) print *, "other sibling: ", trim(np%nodeName)
+             first = .true.
+             np => getNextSibling(np)
+
+        end select
+
+     enddo
+
+    end subroutine normalize
+
+
+end module m_dom_element
Index: trunk/NEMOGCM/EXTERNAL/XMLF90/src/dom/m_dom_error.f90
===================================================================
--- trunk/NEMOGCM/EXTERNAL/XMLF90/src/dom/m_dom_error.f90	(revision 2528)
+++ trunk/NEMOGCM/EXTERNAL/XMLF90/src/dom/m_dom_error.f90	(revision 2528)
@@ -0,0 +1,35 @@
+module m_dom_error
+
+  !-------------------------------------------------------
+  ! EXCEPTION CODES
+  !-------------------------------------------------------
+  integer, parameter, public :: INDEX_SIZE_ERR              = 1
+  integer, parameter, public :: DOMSTRING_SIZE_ERR          = 2
+  integer, parameter, public :: HIERARCHY_REQUEST_ERR       = 3
+  integer, parameter, public :: WRONG_DOCUMENT_ERR          = 4
+  integer, parameter, public :: INVALID_CHARACTER_ERR       = 5
+  integer, parameter, public :: NO_DATA_ALLOWED_ERR         = 6
+  integer, parameter, public :: NO_MODIFICATION_ALLOWED_ERR = 7
+  integer, parameter, public :: NOT_FOUND_ERR               = 8
+  integer, parameter, public :: NOT_SUPPORTED_ERR           = 9
+  integer, parameter, public :: INUSE_ATTRIBUTE_ERR         = 10
+  integer, parameter, public :: INVALID_STATE_ERR           = 11
+  integer, parameter, public :: SYNTAX_ERR                  = 12
+  integer, parameter, public :: INVALID_MODIFICATION_ERR    = 13
+  integer, parameter, public :: NAMESPACE_ERR               = 14
+  integer, parameter, public :: INVALID_ACCESS_ERR          = 15
+  integer, parameter, public :: VALIDATION_ERR              = 16
+  integer, parameter, public :: TYPE_MISMATCH_ERR           = 17
+
+CONTAINS
+
+  subroutine dom_error(name,code,msg)
+    character(len=*), intent(in) :: name, msg
+    integer, intent(in)          :: code
+
+    print *, "***ERROR***"
+    print *, "Routine ", trim(name), ":", trim(msg)
+    print *, 1.0 / sin(3.141592654)
+  end subroutine dom_error
+
+end module m_dom_error
Index: trunk/NEMOGCM/EXTERNAL/XMLF90/src/dom/m_dom_namednodemap.f90
===================================================================
--- trunk/NEMOGCM/EXTERNAL/XMLF90/src/dom/m_dom_namednodemap.f90	(revision 2528)
+++ trunk/NEMOGCM/EXTERNAL/XMLF90/src/dom/m_dom_namednodemap.f90	(revision 2528)
@@ -0,0 +1,203 @@
+module m_dom_namednodemap
+!
+! This is basically a dictionary module, but written with the
+! DOM node structure in mind.
+!
+use m_dom_types
+use m_strings
+
+private
+  !-------------------------------------------------------  
+  ! METHODS FOR NAMEDNODEMAPS
+  !-------------------------------------------------------   
+  public :: getNamedItem
+  public :: setNamedItem
+  public :: removeNamedItem
+
+  public :: item
+  public :: getLength
+  public :: append
+
+  interface append
+     module procedure append_nnm
+  end interface
+
+  interface item
+     module procedure item_nnm
+  end interface 
+
+  interface getLength
+     module procedure getLength_nnm
+  end interface
+
+CONTAINS
+
+  function item_nnm(namedNodeMap, i)
+    
+    integer, intent(in)             :: i
+    type(fnamedNodeMap), pointer    :: namedNodeMap
+    type(fnode), pointer            :: item_nnm
+    
+    type(fnamedNode), pointer :: nnp
+
+    integer :: n
+
+    item_nnm => null()            ! In case there is no such item
+    if (.not. associated(namedNodeMap)) RETURN
+
+    nnp => namedNodeMap%head
+    n = -1
+    do 
+       if (.not. associated(nnp))  exit
+       n = n + 1
+       if (n == i) then
+          item_nnm => nnp%node
+          exit
+       endif
+       nnp => nnp%next
+    enddo
+
+  end function item_nnm
+
+  !----------------------------------------------------------- 
+  
+  function getLength_nnm(namedNodeMap)
+  
+    type(fnamedNodeMap), pointer :: namedNodeMap
+    integer :: getLength_nnm
+
+    getLength_nnm = 0
+    if (.not. associated(namedNodeMap)) return
+
+    getLength_nnm = namedNodeMap % length    
+    
+  end function getLength_nnm
+
+  !----------------------------------------------------------- 
+
+
+  subroutine append_nnm(nodeMap,node)
+    type(fnamednodeMap), pointer :: nodeMap
+    type(fnode), pointer :: node
+
+    if (.not. associated(nodeMap)) then
+       allocate(nodeMap)
+       nodeMap%length = 1
+       allocate(nodeMap%head)
+       nodeMap%head%name = node%nodeName
+       nodeMap%head%node => node
+       nodeMap%tail => nodeMap%head
+    else
+       allocate(nodeMap%tail%next)
+       nodeMap%tail%next%node => node
+       nodeMap%tail%next%name =  node%nodeName
+       nodeMap%tail => nodeMap%tail%next
+       nodeMap%length = nodeMap%length + 1
+    endif
+
+  end subroutine append_nnm
+
+  !----------------------------------------------------------- 
+
+  function getNamedItem(namedNodeMap, name)
+    
+    type(fnamedNodeMap), pointer    :: namedNodeMap
+    character(len=*), intent(in)    :: name
+    type(fnode), pointer            :: getNamedItem
+
+    type(fnamedNode), pointer :: nnp
+
+    getNamedItem => null()
+    if (.not. associated(namedNodeMap)) return 
+
+    nnp => namedNodeMap%head
+    do while (associated(nnp)) 
+       if (nnp%name == name) then
+          getNamedItem => nnp%node
+          exit                 ! one or zero nodes with a given name
+       endif
+       nnp => nnp%next
+    enddo
+
+  end function getNamedItem
+
+  
+  function setNamedItem(namedNodeMap, node)
+
+!!AG: Do we need to clone the node ?
+    
+    type(fnamedNodeMap), pointer    :: namedNodeMap
+    type(fnode), pointer            :: node
+    type(fnode), pointer            :: setNamedItem
+
+    type(fnamedNode), pointer :: nnp
+
+    if (.not. associated(namedNodeMap)) then
+
+       call append(namedNodeMap,node)
+       setNamedItem => node
+      
+    else
+
+       nnp => namedNodeMap%head
+       do while (associated(nnp)) 
+          if (nnp%name == node%nodeName) then
+             setNamedItem => nnp%node
+             nnp%node => node
+             setNamedItem => node
+             return
+          endif
+          nnp => nnp%next
+       enddo
+
+       !   If not found, insert it at the end of the linked list
+
+       call append(namedNodeMap,node)
+       setNamedItem => node
+    endif
+
+  end function setNamedItem
+
+!------------------------------------------------------------
+   function removeNamedItem(namedNodeMap, name)
+    
+    type(fnamedNodeMap), pointer   :: namedNodeMap
+    character(len=*), intent(in)   :: name
+    type(fnode), pointer           :: removeNamedItem
+
+    type(fnamedNode), pointer :: nnp, previous
+
+    removeNamedItem => null()
+    if (.not. associated(namedNodeMap)) return  
+
+    previous => null()
+    nnp => namedNodeMap%head
+    do while (associated(nnp)) 
+       if (nnp%name == name) then
+          removeNamedItem => nnp%node
+          if (associated(nnp,namedNodeMap%head)) then
+             ! we remove the first fnamedNode in the chain...
+             namedNodeMap%head => nnp%next
+          else if (.not. associated(nnp%next)) then
+             ! we remove the last fnamedNode in the chain
+             previous%next => null()
+             namedNodeMap%tail => previous
+          else
+             ! we remove a link in the middle of the chain
+             previous%next => nnp%next
+          endif
+          namedNodeMap%length =  namedNodeMap%length - 1
+          call unstring(nnp%name)
+          deallocate(nnp)
+          EXIT                 ! one or zero nodes with a given name
+       endif
+       previous => nnp
+       nnp => nnp%next
+    enddo
+
+  end function removeNamedItem
+
+
+
+end module m_dom_namednodemap
+
